sub Generate {
    my($sip, $ip);
    my(@iplist) = @_;

# Create Fail, Warn, Ok hashes for requested ip numbers

    foreach $ip (@iplist) {
      $sip = &sip($ip);
      $Site{$mySite{$sip}{'status'}}{$sip}{'ip'}       = $mySite{$sip}{'ip'};
      $Site{$mySite{$sip}{'status'}}{$sip}{'name'}     = $mySite{$sip}{'name'};
      $Site{$mySite{$sip}{'status'}}{$sip}{'alias'}    = $mySite{$sip}{'Alias_8'};
      $Site{$mySite{$sip}{'status'}}{$sip}{'ports'}    = $mySite{$sip}{'ports'};
      $Site{$mySite{$sip}{'status'}}{$sip}{'portlist'} = $mySite{$sip}{'portlist'};
      if ($mySite{$sip}{'os'}) {
        $Site{$mySite{$sip}{'status'}}{$sip}{'os'}    = $mySite{$sip}{'os'};
        $Site{$mySite{$sip}{'status'}}{$sip}{'icon'}  = $mySite{$sip}{'icon'};
      } else {
        $in{'os'}   = &GetOS($ip);
        $in{'icon'} = &GetICON($in{'os'});
        &SaveStoredInfo($ip);
        $Site{$mySite{$sip}{'status'}}{$sip}{'os'}    = $in{'os'};
        $Site{$mySite{$sip}{'status'}}{$sip}{'icon'}  = $in{'icon'};
      }
    }

    return;
}

sub WriteHTMLfiles {

# Create the compact and basic HTML strings and write to files

    my ($o, $found, $cc, $cb, $sip, $c, $b);

    my $compact = "<table border=0 cellspacing=0 cellpadding=0 width=\"100%\">".
                     "<tr><td><span style=\"".$Fxs.
                     "\">Click on a site address for detailed information.</span></td>".
                     "<td nowrap><span style=\"".$Fxs.
                     "\">Status: SITESUP ok, SITESWARN warn, SITESFAIL fail</span></td>".
                     "<td align=\"right\"><span style=\"".$Fxs."\">Created: ".scalar(localtime()).
                     "</span></td></tr></table>\n";
    my $basic   = $compact."<table border=0 cellspacing=2 cellpadding=0>";
    $compact      .= "<table border=0 cellspacing=2 cellpadding=0>";
    my %NumSites;
    $NumSites{$Stat_fail} = $NumSites{$Stat_warn} = $NumSites{$Stat_ok} = 0;

    foreach $o ($Stat_fail, $Stat_warn, $Stat_ok) {
      $found = $cc = $cb = 0;

      foreach $sip (sort keys %{$Site{$o}}) {
        unless ($found) {
          $compact .= "<tr><td colspan=".$Basiccols.
                      "><div style=\"font-weight:bold;color:black;background-color:white\">".
                     (($o == $Stat_fail) ? "Sites not responding" : ($o == $Stat_warn) ? "Sites responding with errors" : "Fully Operational Sites").
                      "</div></td></tr>";

          $basic   .= "<tr><td colspan=".$Basiccols.
                      "><div style=\"font-weight:bold;color:black;background-color:white\">".
                     (($o == $Stat_fail) ? "Sites not responding" : ($o == $Stat_warn) ? "Sites responding with errors" : "Fully Operational Sites").
                      "</div></td></tr>";
        }
        ($c, $b) = &Display2($o, $sip, $cc++, $cb++);
        $NumSites{$o}++;

        $compact .= $c;
        $basic   .= $b;

        $cc = 0 if $cc >= $Basiccols;
        $cb = 0 if $cb >= $Basiccols;

        $found = 1;
      }
      $compact .= "</tr>\n" if $cc;
      $basic   .= "</tr>\n" if $cb;
    }
    $compact .= "</table>\n";
    $basic   .= "</table>\n";

    $compact =~ s!SITESUP!$NumSites{$Stat_ok}!s;
    $compact =~ s!SITESWARN!$NumSites{$Stat_warn}!s;
    $compact =~ s!SITESFAIL!$NumSites{$Stat_fail}!s;
    $basic =~ s!SITESUP!$NumSites{$Stat_ok}!s;
    $basic =~ s!SITESWARN!$NumSites{$Stat_warn}!s;
    $basic =~ s!SITESFAIL!$NumSites{$Stat_fail}!s;
    
    local(*F);
    open(F, ">$Compactresultfile") || &Error("Unable to open result file: $Compactresultfile\n$!");
    #print F &Header($Myname,"compact","",1).$compact.&Footer();
    print F $compact;
    close(F);

    open(F, ">$Basicresultfile") || &Error("Unable to open result file: $Basicresultfile\n$!");
    #print F &Header($Myname,"basic","",1).$basic.&Footer();
    print F $basic;
    close(F);
}


sub Display2 {
    my($o, $sip, $cc, $cb) = @_;
    my($compact, $basic);

    my($color)     = ($o == $Stat_fail) ? $Color_fail : ($o == $Stat_warn) ? $Color_warn : $Color_ok;
    my($textcolor) = ($o == $Stat_fail) ? $Text_fail  : ($o == $Stat_warn) ? $Text_warn  : $Text_ok;

    my($name)      = $Site{$o}{$sip}{'name'};
    my($ip)        = $Site{$o}{$sip}{'ip'};
    my($icon)      = $Site{$o}{$sip}{'icon'};
    my($alias)     = $Site{$o}{$sip}{'alias'};

    $compact = "<tr valign=\"middle\" align=\"center\">\n" unless $cc;
    $basic   = "<tr valign=\"middle\" align=\"center\">\n" unless $cb;

    $compact .= "<td style=\"background-color:".$color."\"><a title=\"".$name."(".($ip eq $name?"":$ip).
                ")\" style=\"text-decoration:none;".$Fxs.";color:".
                $textcolor."\" href=\"".$nPULSEurl."?a=detail&site=".$ip."&returnurl=".
                $Compactdisplay_url."\">".
                ($UseAliases ? &Cname($ip,$name,$alias,$CustomName) : $ip).
                "</a></td>";

    $basic   .= "<td style=\"".$Fss.";border:1 solid black\"><a style=\"".$Fxs.";color:".$textcolor.
                ";text-decoration:none;\" href=\"".
                $nPULSEurl."?a=detail&site=".$ip."&returnurl=".$Basicdisplay_url."\">".
                "<img border=0 width=32 height=32 src=\"/images/".$icon.".gif\"><br>".
                "<span style=\"background-color:".$color."\">".
                ($UseAliases ? &Cname($ip,$name,$alias,$CustomName) : $ip).
                "</span></a></td>\n";

    $compact .= "</tr>\n" if $cc > $Basiccols;
    $basic   .= "</tr>\n" if $cb > $Basiccols;

	return $compact, $basic;
}

sub Cname {
    my($ip,$name,$alias,$type) = @_;
    my(@parts, $i);
    return $ip    unless $name;
    return $name  if (($type <= -1) or ($type > 9));
    return $alias if ($alias and ($type == 0));

    @parts = split(/\./, $name);

    if ($type == 9) {
      pop   @parts unless $#parts <= 0;
      shift @parts unless $#parts <= 0;
    } else {
      $name = $alias || $name;
      for ($i = 1; $i <= $type; $i++) { pop @parts unless $#parts <= 0; }
    }
    return join('.', @parts);
}

sub DisplayHTML {
    my $f = shift || return;
    my $extra = shift;
    local(*F); local($/) = undef;
    open(F, "<$f") || return;
    my $output = <F>;
    close(F);
    my $type = ($f eq $Compactresultfile)?"compact":(($f eq $Basicresultfile)?"basic":"");
    $output = &Header($Myname,$type,$extra,($type?1:0)).$output.&Footer();
    return $output;
}

1;
